I’ve recently started using git, and also begun unit testing (using Python’s unittest module). I’d like to run my tests each time I commit, and only commit if they pass.
I’m guessing I need to use pre-commit in /hooks, and I’ve managed to make it run the tests, but I can’t seem to find a way to stop the commit if they tests fail. I’m running the tests with make test, which in turn is running python3.1 foo.py --test. It seems like I don’t get a different exit condition whether the tests pass or fail, but I may be looking in the wrong place.
Edit: Is this something uncommon that I want to do here? I would have thought it was a common requirement…
Edit2: Just in case people can’t be bothered to read the comments, the problem was that unittest.TextTestRunner doesn’t exit with non-zero status, whether the test suite is successful or not. To catch it, I did:
result = runner.run(allTests)
if not result.wasSuccessful():
sys.exit(1)
I would check to make sure that each step of the way, your script returns a non-zero exit code on failure. Check to see if your
python3.1 foo.py --testreturns a non-zero exit code if a test fails. Check to make sure yourmake testcommand returns a non-zero exit code. And finally, check that yourpre-commithook itself returns a non-zero exit code on failure.You can check for a non-zero exit code by adding
|| echo $?to the end of a command; that will print out the exit code if the command failed.The following example works for me (I’m redirecting stderr to
/dev/nullto avoid including too much extraneous output here):test.py:Makefile:.git/hooks/pre-commit:Note the
|| exit 1. This isn’t necessary ifmake testis the last command in the hook, as the exit status of the last command will be the exit status of the script. But if you have later checks in yourpre-commithook, then you need to make sure you exit with an error; otherwise, a successful command at the end of the hook will cause your script to exit with a status of0.